//
// CORBA.h -- Declarations of basic CORBA types.
//

#ifndef _CORBA_H
#define _CORBA_H

#include <hpcxx_rts.h>

// namespace is, unfortunately, NOT supported on many compilers

//
//namespace CORBA {
//

  class CORBA_Object;		// forward reference
  typedef CORBA_Object* CORBA_Object_ptr;

  class CORBA_Object_var : public HPCxx_GlobalPtr<CORBA_Object> {
   public:

    CORBA_Object_var(void) : HPCxx_GlobalPtr<CORBA_Object>() { }
    CORBA_Object_var(CORBA_Object* ptr) : HPCxx_GlobalPtr<CORBA_Object>(ptr) {}
  };


  // Root class for all CORBA distributed objects.
  class CORBA_Object {

    public: ~CORBA_Object(void) { }

    // returns false if object is NULL
    public: static bool is_nil(CORBA_Object_var obj);

    // returns NULL object
    public: static CORBA_Object_var nil(void);

  };

//
//};
//


//
// inline member functions
//

// returns false if object is NULL
inline bool CORBA_Object::is_nil(CORBA_Object_var obj)
{
  return false;	//FIXME
}

// returns NULL object
inline CORBA_Object_var CORBA_Object::nil(void)
{
  CORBA_Object_var gp;
  return gp;
}


#endif	// _CORBA_H
