// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_CondImpl.h,v 1.1 1998/06/23 00:03:11 ejohnson Exp $

#ifndef __HPCXX_CONDIMPL_H_
#define __HPCXX_CONDIMPL_H_

#include <nexus.h>
#include <HPCxx_MutexImpl.h>

class HPCxx_CondImpl {
private:
  nexus_cond_t      cond_;
  //nexus_condattr_t  attr_;

public:
  HPCxx_CondImpl();
  HPCxx_CondImpl(const HPCxx_CondImpl& cond);

  virtual ~HPCxx_CondImpl();

  HPCxx_CondImpl& operator=(const HPCxx_CondImpl& cond);

  virtual int wait(HPCxx_MutexImpl& mutex);
  virtual int signal();
  virtual int broadcast();
};

#endif
