// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_NodeImpl.C,v 1.1 1998/07/02 16:35:58 rasmussn Exp $

#include <string.h>

#include <HPCxx_NodeImpl.h>

HPCxx_NodeImpl::HPCxx_NodeImpl()
{
}

HPCxx_NodeImpl::HPCxx_NodeImpl(const HPCxx_NodeImpl &node)
{
}

HPCxx_NodeImpl::~HPCxx_NodeImpl()
{
}

  
// Return true if the context is local to this node
bool HPCxx_NodeImpl::contextIsLocal(const HPCxx_ContextID &id)
{
  return true;
}

// Return the number of contexts in this node 
int HPCxx_NodeImpl::getNumContexts()
{
  return 1;
}

// Null terminated list of the contexts in this node
// The caller of this function must 'delete []' the memory
HPCxx_ContextID* HPCxx_NodeImpl::getContexts()
{
  return((HPCxx_ContextID *)0);
}

// Create a new context and add it to this node
int HPCxx_NodeImpl::addContext()
{
  return 0;
}

// Create a new context and run the specified executable
int HPCxx_NodeImpl::addContext(const char *exePath)
{
  return 0;
}
