//
// Copyright (C) 1988 University of Illinois, Urbana, Illinois
// Copyright (C) 1989 University of Colorado, Boulder, Colorado
// Copyright (C) 1990 University of Colorado, Boulder, Colorado
// Copyright (C) 1994 University of Colorado, Boulder, Colorado
//
// written by Dirk Grunwald and Suvas Vajracharya {grunwald,suvas}@foobar.colorado.edu)
//
#ifndef _RedBlackSOR_h_
#define	_RedBlackSOR_h_


#ifdef __GNUG__
#  pragma interface
#endif

#include "Tulip_Thread.h"

class RedBlackSOR : public Tulip_Thread
{
    int chunk;
    int iterations;
    int low;
    int high;
    int globalhigh;
    int globallow;
    int stride;
    int NumCpus;
  public:
    RedBlackSOR(int lo_, int hi_, int glow_, int ghigh_, int str_, int iter_, int chnk_,int num_);
    virtual void run();
};

#endif
