#include <stdio.h>
#include <stdlib.h>
#include "Tulip_Context.h"
#include "Tulip_Timers.h"
#include "Tulip_iolock.h"


class Dome : public Tulip_Thread {
public:

  Dome() : Tulip_Thread("") {
    return;
  }

  virtual void run() {
    BEGIN_PRINT
    cerr << "Running a thread\n" << flush;
    END_PRINT
  }
};


void main(int argc, char** argv)
{
  int cpus = (argc > 1) ? atoi(argv[1]) : 1;
  int debug = (argc > 2) ? atoi(argv[2]) : 0;
  fprintf(stderr,"About to start scheduling..\n");
  //  Tulip_Context SystemContext(cpus,debug);
  Tulip_Context::startVerbose();
  Tulip_Thread *dome = new Dome();
  Tulip_Context::add(dome);
  Tulip_Context::addNWorkers(2);
  fprintf(stderr,"About to yield()\n");
  yield();
  fprintf(stderr,"Back from yield()\n");
  Tulip_Context::endVerbose();

  //  double start = Tulip_StartTimer();
  //  SystemContext.init(cpus,argc,argv);
  //  double delta = Tulip_StopTimer(start);

  //  fprintf(stderr,"Took %f seconds\n", delta);
  //  fprintf(stderr,"Back in main, about to exit\n");
}
