#include <stream.h>
#include "Tulip_Context.h"
#include "Tulip_Timers.h"
#include "Tulip_Semaphore.h"
#include "Tulip_ThreadPipe.h"
#include "Tulip_iolock.h"
#include <limits.h>

#include "Types.h"
#include "Worker.h"

extern void tsp (int, int, Path_t,  int) ;
extern Tulip_PipeList<Node> tsp_queue     ;


Worker::Worker(int n) : Tulip_Thread ("")
{
    num_worker = n ;
}
 
 
void Worker::run()
{
 int  jobcount = 0 ;
 Node n ;
 
 while (tsp_queue.tryGet (n)) 
   {
    jobcount++ ;
 
    tsp (MAXHOPS, n.len, n.path, num_worker) ;
   }
 cout << lock << "Worker [" << num_worker << "] terminates, " << jobcount << " jobs done.\n" << flush << unlock;
}
