/*=======================================================================
 $Log: Tulip_Mutex.h,v $
 Revision 1.1  1998/06/23 00:12:21  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:54:30  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:14:22  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_Mutex.h,v 1.1 1998/06/23 00:12:21 ejohnson Exp $
 $Date: 1998/06/23 00:12:21 $
 $Author: ejohnson $
 ========================================================================*/
//-*-c++-*-
#ifndef _Tulip_Mutex_h_
#define _Tulip_Mutex_h_

#include "Context.h"



class Tulip_Mutex {
  unsigned long slock;
public:
  Tulip_Mutex() {
    slock = 0;
  }

  void lock() {
    Tulip_spinlock(&slock, 1);
  }

  void unlock() {
    slock = 0;
  }
  // Operator overloads
  //  Tulip_Mutex& operator=(const Tulip_Mutex& mutex)
  void operator=(const Tulip_Mutex& mutex)
  {
    slock = mutex.slock;

  }

  long trylock() {
    return Tulip_spintrylock(&slock, 1);
  }

};

#endif


