/*=======================================================================
 $Log: Tulip_Helpers.C,v $
 Revision 1.1  1998/06/23 00:12:56  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:54:47  suvas
 New Release (using main as a thread)

 Revision 1.1  1998/05/15 23:01:45  suvas
 *** empty log message ***

 Revision 1.2  1998/05/12 23:15:23  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_Helpers.C,v 1.1 1998/06/23 00:12:56 ejohnson Exp $
 $Date: 1998/06/23 00:12:56 $
 $Author: ejohnson $
 ========================================================================*/
#ifdef __GNUG__
#  pragma implementation
#endif
#include <Tulip_Helpers.h>
#include <Tulip_Context.h>
#include <pthread.h>
#include <assert.h>


Tulip_ContextPtr Tulip_PrivateContext::operator->(){
  int pid = whoAmI();
  int i;
  for (i=0; i < Tulip_Context::numcpus; i++) {
    if (Tulip_Context::Contexts[i] != NULL)
      if (pid == Tulip_Context::Contexts[i]->pid)
	break;
  }
  return Tulip_Context::Contexts[i];
}
void Tulip_PrivateContext::operator=(const Tulip_ContextPtr& context){
}

int Tulip_Fork(void *fArgs, voidPtrFuncP func){
  pthread_t thread;
  int ret = pthread_create(&thread, NULL, func, fArgs);
  assert(ret == 0);
  if (Tulip_Context::debug)
    cerr << "pthread created \n" << flush;
  return ret;
}


Tulip_PrivateContext::Tulip_PrivateContext()
{

}




