#include <iostream.h>
#include "CUT_AssocCache.h"
#include <stdlib.h>
#include <random.h>

typedef CUT_AssocCache<long,1,5> CacheType;

int
main()
{
  //
  //
  long howmany = 10000000;
  cout << "Insert " << howmany << " references into a 2-way associative cache\n";

  CacheType cache(8);

  for (int i = 0; i < howmany ; i++) {
    unsigned long addr = ::random() % 0x7fff;
    cache.load(addr);
  }
    
  cache.digestable_report(cout,"demo");
}

