#include <iostream.h>
#include "CUT_FlexiCache.h"
#include <stdlib.h>
#include <random.h>

typedef CUT_FlexiCache<long> CacheType;

int
main(int argc, char **argv)
{
  //

  int assoc = 2;
  if ( argc >= 2 ) {
    assoc = atoi(argv[1]);
  }

  int sz = 7;
  if ( argc >= 3 ) {
    sz = atoi(argv[2]);
  }

  long howmany = 10000000;
  cout << "Insert " << howmany << " references into a "
       << assoc << "-way associative cache\n";

  CacheType cache(assoc, sz, 5);

  for (int i = 0; i < howmany ; i++) {
    unsigned long addr = ::random() % 0x7fff;
    cache.load(addr);
  }
    
  cache.digestable_report(cout,"demo");
}

