#include <iostream.h>
#include "CUT_TLBFixed.h"
#include <stdlib.h>
#include <random.h>

typedef CUT_TLBFixed<4,13,1> TlbType;

int
main()
{
  //
  //
  long howmany = 10000000;
  cout << "Insert " << howmany << " TLB references into a small 2-way associative TLB\n";

  TlbType tlb;

  for (int i = 0; i < howmany ; i++) {
    unsigned long addr = ::random() % 0x7fff;

    TlbType::decoded decoded;

    tlb.map_addr(addr, decoded);

    if ( 0 ) {
      cout << "Reference address " << hex << addr << dec;
      cout << " as bank " << decoded.bank_index << ", page " << decoded.page_offset << endl;
    }

    if ( tlb.check_for_hit(decoded) ) {
      tlb.update_tlb(decoded);
    }
  }
    
  tlb.digestable_report(cout,"demo");
}

