/*=======================================================================
 $Log: Tulip_CSem.C,v $
 Revision 1.1  1998/06/23 00:18:05  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:57:30  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:15:54  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_CSem.C,v 1.1 1998/06/23 00:18:05 ejohnson Exp $
 $Date: 1998/06/23 00:18:05 $
 $Author: ejohnson $
 ========================================================================*/
#ifdef __GNUG__
#  pragma implementation
#endif

#include "Tulip_CSem.h"


void Tulip_CSemTemplate::release()
{
//      cerr << lock << " RELEASE!!!!\n" << flush << unlock;  
    Tulip_Thread *p = 0;
    while (container.size() > 0) {
      p = container.front();
      Tulip_Context::add(p);
      container.erase(container.begin());
    }
    genNum++;
}

void Tulip_CSemTemplate::wait() {
  mutex.lock();
  if (pCount < height) {
    mutex.unlock();
    waiting = TRUE;
    // We may need to block - have this done by a third party..
    Tulip_Context::reservation_upcall( this );
  }
  else {
    pCount = 0;
    mutex.unlock();
  }
}
