
#include <stdlib.h>
#include <unistd.h>
#include <stream.h>
#include <signal.h>

#include <nexus.h>
#include <hpcxx_rts.h>
#include "invoke.h"  //i should not be needed.


int quit = 0;


char w;
char foo(float z){
  cout << "hi from foo: arg = " << z << endl;
  return w;
}
void hpcxx_barrier();

int main(int argc, char **argv)
{
  HPCxx_Group *group;
  HPCxx_Sync<int> sync;
  HPCxx_Mutex     mutex;
  HPCxx_Cond      cond;
  hpcxx_id_t      foo_id;

  foo_id = hpcxx_register(foo, 5);

  hpcxx_init(argc, argv, group);

  if (!nexus_master_context()){
     w = 'y';
     printf(" gone fishing\n");
     hpcxx_barrier();
     }
  else{
    w = 'z';
    HPCxx_ContextID *othercid = group->getContextID(1);
    hpcxx_barrier();
    
    cout << "HPC++ Initialized.." << endl;

    char result = 0;
    float arg = 337.0;
    hpcxx_invoke(*othercid, result, foo_id,  arg);
    printf("got the result!!! it is = %c\n", result);
  } // end of master block
 hpcxx_exit(group);
  return(0);
}
