#! /usr/bin/perl

$sep = "-------------------------------------------------------------------\n";
 
%tests = (
  "barnes-hut example "				      => "barnes-hut < inp.bh",
  "quicksort example "				      => "quicksort",
  "matmul example "				      => "matmul"
 );

print $sep;

foreach $key (keys %tests) {
    print "Running: $key\n";
    $rtn = system($tests{$key});
    if ($rtn != 0) {
	print $sep;
	print "FAILED\n";
	print "FAILED  $key\n";
	print "FAILED\n";
	exit;
    }
    print $sep;
}

print "SUCCESS\n";
print "SUCCESS  All tests have completed successfully.\n";
print "SUCCESS\n";


