//
// testBarrier tests the functionality of the hpcxx_barrier function.
//

#include <iostream.h>
#include <hpcxx_rts.h>

int main(int argc, char* argv[])
{
  HPCxx_Group* g;
  hpcxx_init(argc, argv, g);

  // Since hpcxx_init does a barrier at the end, one test is just init and
  // exit (should be done for multiple contexts through the test script).
  int error = hpcxx_exit(g);

  cerr << endl;
  if (error != HPCXX_SUCCESS) {
    cerr << "ERROR, hpcxx_barrier() test did not complete correctly, error = "
	 << error << endl;
    return error;
  } else {
    cout << "Successfully completed hpcxx_barrer() test" << endl;
  }

  return 0;
}
