// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_NodeImpl.C,v 1.2 1998/07/09 23:53:48 sameer Exp $

#include <HPCxx_Profile.h>
#include <string.h>

#include <HPCxx_NodeImpl.h>

HPCxx_NodeImpl::HPCxx_NodeImpl()
{
  TAU_PROFILE("HPCxx_NodeImpl::HPCxx_NodeImpl()", "void ()", TAU_HPCXX);
}

HPCxx_NodeImpl::HPCxx_NodeImpl(const HPCxx_NodeImpl &node)
{
  TAU_PROFILE("HPCxx_NodeImpl::HPCxx_NodeImpl()", "void (HPCxx_NodeImpl &)",
    TAU_HPCXX);

}

HPCxx_NodeImpl::~HPCxx_NodeImpl()
{
  TAU_PROFILE("HPCxx_NodeImpl::~HPCxx_NodeImpl()", "void ()", TAU_HPCXX);
}

  
// Return true if the context is local to this node
bool HPCxx_NodeImpl::contextIsLocal(const HPCxx_ContextID &id)
{
  TAU_PROFILE("HPCxx_NodeImpl::contextIsLocal()", "bool (HPCxx_ContextID &)", 
    TAU_HPCXX);
  // FIXME
  return(true);
}

// Return the number of contexts in this node 
int HPCxx_NodeImpl::getNumContexts()
{
  TAU_PROFILE("HPCxx_NodeImpl::getNumContexts()", "int ()", TAU_HPCXX);
  // FIXME
  return(0);
}

// Null terminated list of the contexts in this node
// The caller of this function must 'delete []' the memory
HPCxx_ContextID *HPCxx_NodeImpl::getContexts()
{
  TAU_PROFILE("HPCxx_NodeImpl::getContexts()", "HPCxx_ContextID * ()", 
    TAU_HPCXX);
  // FIXME
  return((HPCxx_ContextID *)0);
}

// Create a new context and add it to this node
int HPCxx_NodeImpl::addContext()
{
  TAU_PROFILE("HPCxx_NodeImpl::addContext()", "int ()", TAU_HPCXX);
  // FIXME - currently not implemented
  return(0);
}

// Create a new context and run the specified executable
// FIXME - currently not implemented
int HPCxx_NodeImpl::addContext(const char *exePath)
{
  TAU_PROFILE("HPCxx_NodeImpl::addContext()", "int (char *)", TAU_HPCXX);
  // FIXME - currently not implemented
  return(0);
}
