//##########################################################################
// HPC++Lib: An object-oriented class library for high performance
//           parallel programming.
//
// Copyright (c) 1997
//      Indiana University
//      Los Alamos National Laboratory
// 	University of Oregon
// 
// http://www.cs.uoregon.edu/paracomp/tau
// http://www.acl.lanl.gov/Tulip
// http://www.extreme.indiana.edu/HPC++
//
// Sameer Shende, Aida Chouchane
// Pete Beckman, Dennis Gannon, Todd Green, Liz Johnson
//
// HPC++_VER: 
//##########################################################################

#ifndef __HPCXX_PROFILEIMPL_H_
#define __HPCXX_PROFILEIMPL_H_


#       include <stdio.h>
#       include <iostream.h>
#       include <stdlib.h>
#       include <fcntl.h>
#       include <unistd.h>
#       include <nexus.h>

  /* contains the definitions of the profile data structures */
#       include <HPCxx_Profile.h>

#       include <HPCxx_Group.h>
#       include <hpcxx_types.h>


#ifdef PROFILING_ON
#       include <pcxx_timers.h>

//GLOBAL VARIABLES
  extern   int HPCXX_numfunc;
  extern   nexus_mutex_t HPCXX_numfunc_mutex;

#endif/* PROFILING_ON */

#endif /* __HPCXX_PROFILEIMPL_H_ */
