//
//	A timing test for barrier. Everything is in the one file.
//

#include <stdio.h>
#include "Tulip_Context.h"
#include "Tulip_Barrier.h"
#include "BarrierTest.h"

Tulip_Barrier TheBarrier(0);

int BarrierTest::done = 0;

BarrierTest::BarrierTest(int p, char *name)
: Tulip_Thread(name)
{
    pid = p;
}

void
BarrierTest::run()
{
    //
    //    cerr << "BarrierTask " << pid << " starts\n";
    //
    for ( ;; ) {
	TheBarrier.rendezvous();
	//	cerr << lock << "BarrierTask " << pid << " \n" << unlock;
	if ( done ) break;
    }
#if 0
    CERR_ALWAYS_PRE;
    cerr << "Thread " << name() << " exiting..\n";
    CERR_POST;
#endif
}


