/*=======================================================================
 $Log: Tulip_AcquireByUpcall.h,v $
 Revision 1.1  1998/06/23 00:12:06  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:54:24  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:14:11  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_AcquireByUpcall.h,v 1.1 1998/06/23 00:12:06 ejohnson Exp $
 $Date: 1998/06/23 00:12:06 $
 $Author: ejohnson $
 ========================================================================*/
#ifndef Tulip_AcquireByUpcall_h
#define Tulip_AcquireByUpcall_h

#ifdef __GNUG__
#  pragma interface
#  include <bool.h>
#endif
#include "Tulip_Config.h"


class Tulip_Thread;

class Tulip_AcquireByUpcall {

private:
  //
  // Return true if byWho is actually blocked by
  // this call, otherwise, return false
  //
  friend class Tulip_Context;
  virtual bool acquire_by_upcall(Tulip_Thread *byWho) = 0;

public:
  Tulip_AcquireByUpcall();


};
#endif
