/*=======================================================================
 $Log: Tulip_Config.h,v $
 Revision 1.1  1998/06/23 00:12:13  ejohnson
 moving directory hpcxx_rts up

 Revision 2.1  1998/06/15 13:11:14  suvas
 *** empty log message ***

 Revision 2.0  1998/05/22 16:54:27  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:14:17  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_Config.h,v 1.1 1998/06/23 00:12:13 ejohnson Exp $
 $Date: 1998/06/23 00:12:13 $
 $Author: ejohnson $
 ========================================================================*/
#ifndef Tulip_Config_h
#define Tulip_Config_h

/* ==========================================*/
/*        IMPLEMENTATION SPECIFICS           */
/* ==========================================*/

#define Tulip_MAX_CPUS 32

#ifndef TRUE
#define TRUE 1
#undef FALSE
#define FALSE 0
#endif

#if defined(__sparc)
#ifndef bool
#include <bool.h>
#endif
#endif

static const int DefaultTulipSpinBarrierLoops = 1000;
static const int DefaultTulipBarrierLoops = 100;

typedef volatile int VolatileInt;
typedef volatile short VolatileShort;
typedef volatile unsigned char  VolatileUsignedChar;

//typedef void (*voidPtrFuncP2)(void *, void *);

#if defined(__sparc) || defined(__alpha)
#  define RETURN_TYPE void* 
#elif defined(LINUX)
#  define RETURN_TYPE int
#else
#  define RETURN_TYPE void 
#endif

#ifdef __alpha
#define _RWSTD_NO_COMPLEX_DEFAULT_TEMPLATES
#endif

typedef RETURN_TYPE (*voidPtrFuncP)(void *);

//typedef void (*voidPtrFuncP2)(int, void *);

#endif


