#ifndef _MainThread_h_
#define	_MainThread_h_

#ifdef __GNUG__
#  pragma interface
#endif
#include "Tulip_Thread.h"
class MainThread : public Tulip_Thread
{
 public:
  MainThread() : Tulip_Thread("Main Thread", 4*default_stack_size){};
  void run(){
  }; 
};
extern MainThread mainThread;
inline
bool isAlive() {
  return mainThread.isAlive();
}     
inline
void suspend() {
  mainThread.suspend();
}
inline
void resume() {
  mainThread.resume();
}
inline
int getThreadID(){
  return mainThread.getThreadID();
}
inline 
void start()
{
  mainThread.start();
}


inline 
void join(const Tulip_Thread &withThread){
  mainThread.join(withThread);
}
#endif

