/*=======================================================================
 $Log: ContextC.C,v $
 Revision 1.1  1998/06/23 00:13:25  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:55:04  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:15:43  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: ContextC.C,v 1.1 1998/06/23 00:13:25 ejohnson Exp $
 $Date: 1998/06/23 00:13:25 $
 $Author: ejohnson $
 ========================================================================*/
#include "Context.h"
#include <stdio.h>
extern "C" {
void Tulip_trampoline();
}
void
Tulip_InitNP(Tulip_NonPremptiveContext *context,
	     Tulip_U64 *stack,
	     void *routine,
	     void *argument)
{
  
  /*
    *	To build a thread, we return to the first address of startOff,
    *	which will use the current FP & SP to build a local context,
    *	and then call the user main.
    *
    *	startOff needs to have a valid frame. The return address for this
    *	frame is NULL, since we never exit procedure startOff.
    */


  stack[0] = (Tulip_U64 ) 'FOO';
  stack[-1] = 0;
  stack[-2] = (Tulip_U64) &stack[-1];
  stack[-3] = (Tulip_U64) &stack[-2];

  context -> R31 = (Tulip_U64) Tulip_trampoline; /* return address */
  context -> R16 =  (Tulip_U64) argument;        /* s0 */
  context -> R17 = (Tulip_U64) routine;          /* s1 */
  context -> R29 = (Tulip_U64) &stack[-3];       /* sp */
  Tulip_SetNonPremptiveResume(context);

}
extern void
Tulip_SetResume(Tulip_NonPremptiveContext *context,
		void * routine)
{
  context -> resume = (Tulip_voidfuncptr)routine;
}
