#include <iostream.h>
#include "CUT_TychoCache.h"
#include <stdlib.h>
#include <random.h>

int
main()
{
  //
  //
  long howmany = 10000000;
  cout << "Insert " << howmany << " TLB references into a small 2-way associative TLB\n";

  CUT_TychoCache cache(32, 7, 10, 2);

  for (int i = 0; i < howmany ; i++) {
    unsigned long addr = ::random() % 0x7fff;
    cache.for_each_reference(addr);
  }
    
  cache.fini(cout);
}

