/* the following describes the layout */
/*   of the Tulip_NonPremptiveContext */
	
NPC_resume =	0
NPC_R1	=	(1*4)    /* SP */
NPC_R2	=	(2*4)    /* PC */
NPC_R3	=	(3*4)    /* out0 */
NPC_R4	=	(4*4)    /* out1 */
	
	.text	
	.align	4
	.globl	Tulip_SaveNP
	
Tulip_SaveNP:
	
/*  On entry: */
/*    %i0 = resurrect context*/
/*    %i1 = hook body */
/*    %i2 = hook data */
/*    %i3 = saveto */

/* On exit, we jump to resurrect -> resume with */
/*    %i0 = resurrect context*/
/*    %i1 = hook body */
/*    %i2 = hook data */

	ta	3
	st	%sp,[%o3+4]		/* save sp */
	st	%o7,[%o3+8]		/* save pc */

	ld	[%o0+0],%i0	
	jmp	%i0
	nop
	.align	4
	.globl	Tulip_RestoreNP

	/* On entry: */
/*  On entry: */
/*    %o0 = resurrect context*/
/*    %o1 = hook body */
/*    %o2 = hook data */

	
Tulip_RestoreNP:
	mov	%o0, %i0
	mov	%o1, %i1
	mov	%o2, %i2
/* prepare to call hook function */


/* Now, call the 'resumption hook' if there is one (in A1), */
/* moving argument into argument register */

	cmp	%i1, 0		/* check if param 2 is null */
	be	.LL2

	mov	%i2, %o0	/* get param 2, hook body */	
	call	%i1,0
	nop

.LL2:
	/*	load destn %sp to o3 */
	ld	[%i0+ 4],%o3
	ld	[%i0+ 8],%o7
	ld	[%i0+ 12], %o0	/* out0 */ 
	ld	[%i0+ 16],%o1	/* out1 */
	
	add %o3,-64,%sp
	
	ld	[%o3+ 0],%l0
	ld	[%o3+ 4],%l1
	ld	[%o3+ 8],%l2
	ld	[%o3+ 12],%l3	
	ld	[%o3+16],%l4
	ld	[%o3+20],%l5	
	ld	[%o3+24],%l6

	ld	[%o3+32],%i0
	ld	[%o3+36],%i1	
	ld	[%o3+40],%i2
	ld	[%o3+44],%i3	
	ld	[%o3+48],%i4
	ld	[%o3+52],%i5	
	ld	[%o3+56],%i6
	ld	[%o3+60],%i7	
	retl
	mov %o3,%sp

	.align	4
	.text
	.globl	Tulip_trampoline


/* On entry: */
/*    %i0 = argument for routine we transfer to */
/*    %i1 = address for routine we're going to */

/* On exit, we jump to specified routine. */


Tulip_trampoline:
	call %o1,0	
	nop		
	ret
	nop
		

	