/*=======================================================================
 $Log: Tulip_GenericTimer.C,v $
 Revision 1.1  1998/06/23 00:18:10  ejohnson
 moving directory hpcxx_rts up

 Revision 2.0  1998/05/22 16:57:31  suvas
 New Release (using main as a thread)

 Revision 1.2  1998/05/12 23:15:56  suvas
 This may look like C code, but it is really C++

 Copyright (c) 1998 Los Alamos National Laboratory
 Copyright (c) 1997 University of Colorado, Boulder

 Suvas Vajracharya and Dirk Grunwald

 $Id: Tulip_GenericTimer.C,v 1.1 1998/06/23 00:18:10 ejohnson Exp $
 $Date: 1998/06/23 00:18:10 $
 $Author: ejohnson $
 ========================================================================*/
#ifdef __GNUG__
#  pragma implementation
#endif

#include <sys/types.h>
#include <sys/times.h>
#include <unistd.h>
#include "Tulip_Timers.h"


double Tulip_StartTimer()
{
  struct tms tim;
  return(times(&tim)); 
}

double Tulip_StopTimer(double start)
{
  struct tms tim;
  double eltime = (times(&tim) - start)/sysconf(_SC_CLK_TCK); 
  return eltime;
}
