#! /usr/bin/perl

$sep = "-------------------------------------------------------------------\n";
 
%tests = (
  "Hello Thread Demonstration/Test"                   => "hello 3",
  "Watch Condition-Variable Demonstration/Test"       => "watch",
  "Reader/Writer Lock Demonstration/Test"             => "ReaderWriter",
  "Red Black SOR Demonstration/Test (~30 sec to run)" => "RedBlackSOR 2"
 );

print $sep;

foreach $key (keys %tests) {
    print "Running: $key\n";
    $rtn = system($tests{$key});
    if ($rtn != 0) {
	print $sep;
	print "FAILED\n";
	print "FAILED  $key\n";
	print "FAILED\n";
	exit;
    }
    print $sep;
}

print "SUCCESS\n";
print "SUCCESS  All tests have completed successfully.\n";
print "SUCCESS\n";


