#include <stdlib.h>
#include <unistd.h>
#include <stream.h>
#include <signal.h>

#include <hpcxx_rts.h>

#define ElapseTime(Start, Stop) \
    (  (  ( ((double)(Stop.tv_sec)) - ((double)(Start.tv_sec)) ) \
        + (((double)(Stop.tv_usec))/1000000.0) ) \
     - (((double)(Start.tv_usec))/1000000.0) )

void *_nx_st_rsh_info(void)
{
  return(NULL);
} 
#include <stdio.h>

template <class T>
class MyThread: public HPCxx_Thread{
   HPCxx_Sync<int> &c;
   HPCxx_Runnable *theObject;
   T x;
  public:
    MyThread( HPCxx_Sync<int> & s ): c(s), HPCxx_Thread(){
       printf("constructor complete\n");
       }
    void run(){
       printf("hi from thread\n");
       int a = 1;
       c.write(a);
       printf("done with write\n");
    }
};

template < class T>
int foo(T x){
    HPCxx_Sync<int> c;
    MyThread<int> t(c);
    t.start();
    c.read(x);
   return 0;
}

int main(int argc, char *argv[]){
    HPCxx_Group *g;
    hpcxx_init(argc, argv, g);
    int x;
    foo(x);
    printf("done with read\n");
    hpcxx_exit(g);
    return(0);
} /* main() */
    
