//##########################################################################
// HPC++Lib: An object-oriented class library for high performance 
//           parallel programming.
//
// Copyright (c) 1997
//	Indiana University
//	Los Alamos National Laboratory
// 
// http://www.acl.lanl.gov/Tulip
// http://www.extreme.indiana.edu/HPC++
// 
// Pete Beckman, Dennis Gannon, Todd Green, Liz Johnson
//
// HPC++_VER: $Id: HPCxx_SyncCell.h,v 1.1 1998/06/23 00:55:47 ejohnson Exp $
//##########################################################################

#ifndef __HPCXX_SYNCCELL_H_
#define __HPCXX_SYNCCELL_H_

template<class T>
struct HPCxx_SyncCell {
  T data_;
  HPCxx_SyncCell<T> *next_;
  HPCxx_SyncCell(): next_((HPCxx_SyncCell<T> *)0) {}
  HPCxx_SyncCell(T& data) : data_(data), next_((HPCxx_SyncCell<T> *)0) {}
};

#endif
