#! /usr/bin/perl

$sep = "-------------------------------------------------------------------\n";
 
%tests = (
#  "Use Buffer with primitive types Test"            => "TestBuffer 1",
#  "Use Buffer with user-def-objects Test"           => "TestBuffer 2",
  "Synchronous and Asynchronous Global Function Invokation Test"           => "TestRMFI_Invoke -nx -n 1",
  "Synchronous and Asynchronous Member Function Invokation Test"           => "TestRMFI_MInvoke -nx -n 2",
  "Global Pointer Manipulation Test"                => "TestGP -nx -n 1"
 );

print $sep;

foreach $key (keys %tests) {
    print "Running: $key\n";
    $rtn = system($tests{$key});
    if ($rtn != 0) {
        print $sep;
        print "FAILED\n";
        print "FAILED  $key\n";
        print "FAILED\n";
        exit;
    }
    print $sep;
}

print "SUCCESS\n";
print "SUCCESS  All tests have completed successfully.\n";
print "SUCCESS\n";
